----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    14:26:23 02/06/2014 
-- Design Name: 
-- Module Name:    ToplevelHDL - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity ToplevelHDL is
    Port ( CLK_IN : in  STD_LOGIC;
           CLK_0N : out  STD_LOGIC;
           CLK_1P : out  STD_LOGIC;
           CLK_2P : out  STD_LOGIC;
           CLK_3P : out  STD_LOGIC;
           CLK_4P : out  STD_LOGIC;
           CLK_5P : out  STD_LOGIC;
           A : out  STD_LOGIC;
           B : out  STD_LOGIC;
           C : out  STD_LOGIC;
           D : out  STD_LOGIC;
           E : out  STD_LOGIC;
           F : out  STD_LOGIC;
           CLKx3 : out  STD_LOGIC);
end ToplevelHDL;

architecture Behavioral of ToplevelHDL is
	signal i_clk_0n : STD_LOGIC;
	signal i_clk_1p : STD_LOGIC;
	signal i_clk_2p : STD_LOGIC;
	signal i_clk_3p : STD_LOGIC;
	signal i_clk_4p : STD_LOGIC;
	signal i_clk_5p : STD_LOGIC;
	signal i_clk_1n : STD_LOGIC;
	signal i_clk_2n : STD_LOGIC;
	signal i_clk_3n : STD_LOGIC;
	signal i_clk_4n : STD_LOGIC;
	signal i_clk_5n : STD_LOGIC;
	signal i_a      : STD_LOGIC;
	signal i_b      : STD_LOGIC;
	signal i_c      : STD_LOGIC;
	signal i_d      : STD_LOGIC;
	signal i_e      : STD_LOGIC;
	signal i_f      : STD_LOGIC;
	signal i_ab     : STD_LOGIC;
	signal i_abn    : STD_LOGIC;
	signal i_cd     : STD_LOGIC;
	signal i_cdn    : STD_LOGIC;
begin

process(CLK_IN, i_clk_0n,
   i_clk_1p, i_clk_2p, i_clk_3p, i_clk_4p, i_clk_5p,
	i_clk_1n, i_clk_2n, i_clk_3n, i_clk_4n, i_clk_5n,  
   i_a, i_b, i_c,i_d, i_e, i_f,   i_ab, i_abn)
   CONSTANT  t_buf : time := 58 ns;  -- min:55  max:69
   CONSTANT  t_hc  : time := 10 ns;
begin

	-- delay line with inverters  HCF40098
	if(CLK_IN'event) then
		i_clk_1p <= not CLK_IN after t_buf;        --one inv
	end if;
	if(i_clk_1p'event) then
		i_clk_2p <= not i_clk_1p after t_buf;      --one inv
	end if;
	if(i_clk_2p'event) then
		i_clk_3p <= not i_clk_2p after t_buf;      --one inv
	end if;
	if(i_clk_3p'event) then
		i_clk_4p <= not i_clk_3p after t_buf;      --one inv
	end if;
	if(i_clk_4p'event) then
		i_clk_5p <= not i_clk_4p after t_buf;      --one inv
	end if;
	
	-- 6x inverters 74hc04
	if(CLK_IN'event) then
		i_clk_0n <= not CLK_IN after t_hc;
	end if;
	if(i_clk_1p'event) then
		i_clk_1n <= not i_clk_1p after t_hc;
	end if;
	if(i_clk_2p'event) then
		i_clk_2n <= not i_clk_2p after t_hc;
	end if;
	if(i_clk_3p'event) then
		i_clk_3n <= not i_clk_3p after t_hc;
	end if;
	if(i_clk_4p'event) then
		i_clk_4n <= not i_clk_4p after t_hc;
	end if;
	if(i_clk_5p'event) then
		i_clk_5n <= not i_clk_5p after t_hc;
	end if;
	
	-- combine delays to new clock (using NANDs)
	-- 6x nand 74hc00
	if(CLK_IN'event or i_clk_1p'event) then
		i_a <= CLK_IN nand i_clk_1p after t_hc;   -- one nand
	end if;
	if(i_clk_3p'event or i_clk_2p'event) then
		i_b <= i_clk_3p nand i_clk_2p after t_hc;   -- one nand
	end if;
	if(i_clk_5p'event or i_clk_4P'event) then
		i_c <= i_clk_5P nand i_clk_4p after t_hc; -- one nand
	end if;
	
	if(i_clk_1n'event or i_clk_0n'event) then
		i_d <= i_clk_1n nand i_clk_0n after t_hc;
	end if;
	if(i_clk_2n'event or i_clk_3n'event) then
		i_e <= i_clk_2n nand i_clk_3n after t_hc;
	end if;
	if(i_clk_4n'event or i_clk_5n'event) then
		i_f <= i_clk_4n nand i_clk_5n after t_hc;
	end if;
	
	-- final combination to clkx3
	-- 6x and/nand
	   -- 74HC30 	74HC30 8-input NAND Gate
	if(i_a'event or i_b'event or i_c'event or i_d'event or i_e'event or i_f'event) then
		--CLKx3 <= i_a and i_b and i_c and i_d and i_e and i_f after t_hc; -- one 6x and
		CLKx3 <= ((i_a nand i_b) xor (i_c nand i_d)) xor (i_e nand i_f) after t_hc; -- 3x nand and
	end if;

--	if(i_a'event or i_b'event) then
--		i_ab <= (i_a nand i_b) after t_hc; --one nand
--	end if;
--	if(i_c'event or i_d'event) then
--		i_cd <= (i_c nand i_d) after t_hc; --one nand
--	end if;
	
--	if(i_ab'event) then
--		i_abn <= not i_AB after t_hc; -- one inv
--	end if;
--	if(i_cd'event) then
--		i_cdn <= not i_cd after t_hc; -- one inv
--	end if;
--	if(i_abn'event or i_cdn'event) then
--		CLKx3 <= i_abn nand i_cdn after t_hc; -- one nand
--	end if;
	
	CLK_1P <= i_clk_1n;
	CLK_2P <= i_clk_2p;
	CLK_3P <= i_clk_3n;
	CLK_4P <= i_clk_4p;
	CLK_5P <= i_clk_5n;
	A <= i_a;
	B <= i_b;
	C <= i_c;
	D <= i_d;
	E <= i_e;
	F <= i_f;
	CLK_0N <= i_clk_0n;
	
end process;


end Behavioral;

